
import AccessControl



def add_commas(self, str1, str2):
    return str1 + '; ' + str2


def allowed_systems(self, user, systems):
  allowed = []
  for system in systems:
    #Does this take too long?
    sm = AccessControl.getSecurityManager()
    user =  sm.getUser()
    if user.has_permission("View",system[1]):
      allowed.append(system)
  return allowed


def access_to_host_allowed(self, hostname, allowed_systems):
  for system in allowed_systems:
    if system[0] == hostname:
      if len(self.allowed_systems(None, [system])) == 1:
          return True
      else:
          return False
  return False



# removes systems that user is not authorized access to
def get_systems_statuses(self, systems):
    ss = {}
    ass = self.allowed_systems(self, None, systems)
    for system in ass:
        hostname = system[0]
        OS = ''
        cluname = ''
        cluali = ''
        authed = False
        ricci = self.get_ricci_communicator(hostname, ass)
        if ricci != None:
            OS = ricci.os()
            cluname = ricci.cluster_info()[0]
            cluali = ricci.cluster_info()[1]
            authed = ricci.authed()
        else:
            OS = 'System not accessible'
        s = {'hostname' : hostname,
             'OS'       : OS,
             'cluname'  : cluname,
             'clualias' : cluali, 
             'available': ricci != None,
             'authed'   : authed}
        ss[hostname] = s
        pass
    ss_list = []
    sorted_keys = ss.keys()
    sorted_keys.sort()
    for name in sorted_keys:
        ss_list.append(ss[name])
    return ss_list




def set_persistant_var(self,
                       var_name,
                       default_value):
    request = self.REQUEST
    response = request.RESPONSE
    session = request.SESSION
    
    # TODO: add username into cookie_prefix, so users don't overwrite each other
    cookie_prefix = '__luci_storage_cookie_'
    
    value = default_value
    if request.has_key(var_name):
        value = request[var_name]
    elif session.has_key(var_name):
        value = session[var_name]
    elif request.cookies.has_key(cookie_prefix + var_name):
        value = request.cookies[cookie_prefix + var_name]
    
    session.set(var_name,
                value)
    response.setCookie(cookie_prefix + var_name,
                       value, 
                       expires='Tue, 30 Jun 2060 12:00:00 GMT')
    
    return value




# returns (str(float), units) that fits best,
# ignores prefered units
def bytes_to_value_units(bytes):
    units = 'TB'
    if float(convert_bytes(bytes, 'GB')) < 1024:
        units = 'GB'
    if float(convert_bytes(bytes, 'MB')) < 1024:
        units = 'MB'
    if float(convert_bytes(bytes, 'KB')) < 1024:
        units = 'KB'
    if float(convert_bytes(bytes, 'bytes')) < 1024:
        units = 'bytes'
    return (convert_bytes(bytes, units), units)

# returns (str(float), units) that fits best,
# takes prefered units into account
def bytes_to_value_prefunits(self, bytes):
    p_units = self.REQUEST.SESSION.get('preferred_size_units')
    dummy, units = bytes_to_value_units(bytes)
    if get_units_multiplier(units) > get_units_multiplier(p_units):
        units = p_units
    return (convert_bytes(bytes, units), units)

def get_units_multiplier(units):
    if units.lower() == 'bytes':
        return 1.0
    elif units.lower() == 'kb':
        return 1024.0
    elif units.lower() == 'mb':
        return 1024*1024.0
    elif units.lower() == 'gb':
        return 1024*1024*1024.0
    elif units.lower() == 'tb':
        return 1024*1024*1024*1024.0
    else:
        raise "invalid size unit"

def convert_bytes(bytes, units):
    c = int(bytes) / get_units_multiplier(units)
    c = str(c)
    c = c[:c.find('.') + 3]
    return c
